/*********************************************************************/
/* dhn.c        v 2.3      by J.Sobczyk IAPW       2001.08.02  17:01 */
/*                                                                   */
/* Polish document converter.                                        */
/* DHN                                                               */
/*********************************************************************/
#include <stdio.h>
#include "polcnv.h"

/*********************************************************************/
code_tbl dhn_tbl =
  {
    { 0x089,   0x0105 },   /* LATIN SMALL LETTER A WITH OGONEK */
    { 0x08a,   0x0107 },   /* LATIN SMALL LETTER C WITH ACUTE */
    { 0x08b,   0x0119 },   /* LATIN SMALL LETTER E WITH OGONEK */
    { 0x08c,   0x0142 },   /* LATIN SMALL LETTER L WITH STROKE */
    { 0x08d,   0x0144 },   /* LATIN SMALL LETTER N WITH ACUTE */
    { 0x08e,   0x00F3 },   /* LATIN SMALL LETTER O WITH ACUTE */
    { 0x08f,   0x015B },   /* LATIN SMALL LETTER S WITH ACUTE */
    { 0x091,   0x017A },   /* LATIN SMALL LETTER Z WITH ACUTE */
    { 0x090,   0x017C },   /* LATIN SMALL LETTER Z WITH DOT ABOVE */
    { 0x080,   0x0104 },   /* LATIN CAPITAL LETTER A WITH OGONEK */
    { 0x081,   0x0106 },   /* LATIN CAPITAL LETTER C WITH ACUTE */
    { 0x082,   0x0118 },   /* LATIN CAPITAL LETTER E WITH OGONEK */
    { 0x083,   0x0141 },   /* LATIN CAPITAL LETTER L WITH STROKE */
    { 0x084,   0x0143 },   /* LATIN CAPITAL LETTER N WITH ACUTE */
    { 0x085,   0x00D3 },   /* LATIN CAPITAL LETTER O WITH ACUTE */
    { 0x086,   0x015A },   /* LATIN CAPITAL LETTER S WITH ACUTE */
    { 0x088,   0x0179 },   /* LATIN CAPITAL LETTER Z WITH ACUTE */
    { 0x087,   0x017B }    /* LATIN CAPITAL LETTER Z WITH DOT ABOVE */
  };

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
int test_dhn( void )
  {
  return table_test( dhn_tbl, 2*POL_NR );
  }

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
void init_dhn( void )
  {
  trans[ TYPE_DHN ].key			= (char*)"";
  trans[ TYPE_DHN ].long_key		= (char*)"-dhn";
  trans[ TYPE_DHN ].name		= (char*)"DHN";
  trans[ TYPE_DHN ].reset_inp       	= NULL;
  trans[ TYPE_DHN ].reset_out       	= NULL;
  trans[ TYPE_DHN ].decode          	= table_decode;
  trans[ TYPE_DHN ].encode          	= table_encode;
  trans[ TYPE_DHN ].inp_tbl         	= dhn_tbl;
  trans[ TYPE_DHN ].inp_tbl_size    	= 2*POL_NR;
  trans[ TYPE_DHN ].out_tbl         	= dhn_tbl;
  trans[ TYPE_DHN ].out_tbl_size    	= 2*POL_NR;
  trans[ TYPE_DHN ].buf_tst         	= NULL;
  trans[ TYPE_DHN ].freq_tst        	= test_dhn;
  }

/*********************************************************************/
