/*********************************************************************/
/* iso.c        v 2.3      by J.Sobczyk IAPW       2001.08.02  17:01 */
/*                                                                   */
/* Polish document converter.                                        */
/* ISO 8859-2                                                        */
/* PN-93/T-42118 (equiv. ISO/IEC 10367:1991)                         */
/*********************************************************************/
#include <stdio.h>
#include "polcnv.h"

/*-------------------------------------------------------------------*/
#define SIZE_ISO_8859_2 57
unicode iso_8859_2_tbl[SIZE_ISO_8859_2][2] = /* Latin 2 ISO 8859-2 */
  {
    { 0x0A1,  0x0104 },	/* LATIN CAPITAL LETTER A WITH OGONEK */
    { 0x0A2,  0x02D8 },	/* BREVE */
    { 0x0A3,  0x0141 },	/* LATIN CAPITAL LETTER L WITH STROKE */
    { 0x0A5,  0x013D },	/* LATIN CAPITAL LETTER L WITH CARON */
    { 0x0A6,  0x015A },	/* LATIN CAPITAL LETTER S WITH ACUTE */
    { 0x0A9,  0x0160 },	/* LATIN CAPITAL LETTER S WITH CARON */
    { 0x0AA,  0x015E },	/* LATIN CAPITAL LETTER S WITH CEDILLA */
    { 0x0AB,  0x0164 },	/* LATIN CAPITAL LETTER T WITH CARON */
    { 0x0AC,  0x0179 },	/* LATIN CAPITAL LETTER Z WITH ACUTE */
    { 0x0AE,  0x017D },	/* LATIN CAPITAL LETTER Z WITH CARON */
    { 0x0AF,  0x017B },	/* LATIN CAPITAL LETTER Z WITH DOT ABOVE */
    { 0x0B1,  0x0105 },	/* LATIN SMALL LETTER A WITH OGONEK */
    { 0x0B2,  0x02DB },	/* OGONEK */
    { 0x0B3,  0x0142 },	/* LATIN SMALL LETTER L WITH STROKE */
    { 0x0B5,  0x013E },	/* LATIN SMALL LETTER L WITH CARON */
    { 0x0B6,  0x015B },	/* LATIN SMALL LETTER S WITH ACUTE */
    { 0x0B7,  0x02C7 },	/* CARON */
    { 0x0B9,  0x0161 },	/* LATIN SMALL LETTER S WITH CARON */
    { 0x0BA,  0x015F },	/* LATIN SMALL LETTER S WITH CEDILLA */
    { 0x0BB,  0x0165 },	/* LATIN SMALL LETTER T WITH CARON */
    { 0x0BC,  0x017A },	/* LATIN SMALL LETTER Z WITH ACUTE */
    { 0x0BD,  0x02DD },	/* DOUBLE ACUTE ACCENT */
    { 0x0BE,  0x017E },	/* LATIN SMALL LETTER Z WITH CARON */
    { 0x0BF,  0x017C },	/* LATIN SMALL LETTER Z WITH DOT ABOVE */
    { 0x0C0,  0x0154 },	/* LATIN CAPITAL LETTER R WITH ACUTE */
    { 0x0C3,  0x0102 },	/* LATIN CAPITAL LETTER A WITH BREVE */
    { 0x0C5,  0x0139 },	/* LATIN CAPITAL LETTER L WITH ACUTE */
    { 0x0C6,  0x0106 },	/* LATIN CAPITAL LETTER C WITH ACUTE */
    { 0x0C8,  0x010C },	/* LATIN CAPITAL LETTER C WITH CARON */
    { 0x0CA,  0x0118 },	/* LATIN CAPITAL LETTER E WITH OGONEK */
    { 0x0CC,  0x011A },	/* LATIN CAPITAL LETTER E WITH CARON */
    { 0x0CF,  0x010E },	/* LATIN CAPITAL LETTER D WITH CARON */
    { 0x0D0,  0x0110 },	/* LATIN CAPITAL LETTER D WITH STROKE */
    { 0x0D1,  0x0143 },	/* LATIN CAPITAL LETTER N WITH ACUTE */
    { 0x0D2,  0x0147 },	/* LATIN CAPITAL LETTER N WITH CARON */
    { 0x0D5,  0x0150 },	/* LATIN CAPITAL LETTER O WITH DOUBLE ACUTE */
    { 0x0D8,  0x0158 },	/* LATIN CAPITAL LETTER R WITH CARON */
    { 0x0D9,  0x016E },	/* LATIN CAPITAL LETTER U WITH RING ABOVE */
    { 0x0DB,  0x0170 },	/* LATIN CAPITAL LETTER U WITH DOUBLE ACUTE */
    { 0x0DE,  0x0162 },	/* LATIN CAPITAL LETTER T WITH CEDILLA */
    { 0x0E0,  0x0155 },	/* LATIN SMALL LETTER R WITH ACUTE */
    { 0x0E3,  0x0103 },	/* LATIN SMALL LETTER A WITH BREVE */
    { 0x0E5,  0x013A },	/* LATIN SMALL LETTER L WITH ACUTE */
    { 0x0E6,  0x0107 },	/* LATIN SMALL LETTER C WITH ACUTE */
    { 0x0E8,  0x010D },	/* LATIN SMALL LETTER C WITH CARON */
    { 0x0EA,  0x0119 },	/* LATIN SMALL LETTER E WITH OGONEK */
    { 0x0EC,  0x011B },	/* LATIN SMALL LETTER E WITH CARON */
    { 0x0EF,  0x010F },	/* LATIN SMALL LETTER D WITH CARON */
    { 0x0F0,  0x0111 },	/* LATIN SMALL LETTER D WITH STROKE */
    { 0x0F1,  0x0144 },	/* LATIN SMALL LETTER N WITH ACUTE */
    { 0x0F2,  0x0148 },	/* LATIN SMALL LETTER N WITH CARON */
    { 0x0F5,  0x0151 },	/* LATIN SMALL LETTER O WITH DOUBLE ACUTE */
    { 0x0F8,  0x0159 },	/* LATIN SMALL LETTER R WITH CARON */
    { 0x0F9,  0x016F },	/* LATIN SMALL LETTER U WITH RING ABOVE */
    { 0x0FB,  0x0171 },	/* LATIN SMALL LETTER U WITH DOUBLE ACUTE */
    { 0x0FE,  0x0163 },	/* LATIN SMALL LETTER T WITH CEDILLA */
    { 0x0FF,  0x02D9 } 	/* DOT ABOVE */
  };

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
int test_iso_8859_2( void )
  {
  return table_test( iso_8859_2_tbl, SIZE_ISO_8859_2 );
  }

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
void init_iso_8859_2( void )
  {
  trans[ TYPE_ISO_8859_2 ].key                = (char*)"-i";
  trans[ TYPE_ISO_8859_2 ].long_key           = (char*)"-iso-8859-2";
  trans[ TYPE_ISO_8859_2 ].name               = (char*)"ISO 8859-2 Latin 2";
  trans[ TYPE_ISO_8859_2 ].reset_inp          = NULL;;
  trans[ TYPE_ISO_8859_2 ].reset_out          = NULL;;
  trans[ TYPE_ISO_8859_2 ].decode             = table_decode;
  trans[ TYPE_ISO_8859_2 ].encode             = table_encode;
  trans[ TYPE_ISO_8859_2 ].inp_tbl            = iso_8859_2_tbl;
  trans[ TYPE_ISO_8859_2 ].inp_tbl_size       = SIZE_ISO_8859_2;
  trans[ TYPE_ISO_8859_2 ].out_tbl            = iso_8859_2_tbl;
  trans[ TYPE_ISO_8859_2 ].out_tbl_size       = SIZE_ISO_8859_2;
  trans[ TYPE_ISO_8859_2 ].buf_tst            = NULL;
  trans[ TYPE_ISO_8859_2 ].freq_tst           = test_iso_8859_2;
  }

/*********************************************************************/
