/*********************************************************************/
/* latin.c      v 2.3      by J.Sobczyk IAPW       2001.08.02  17:01 */
/*                                                                   */
/* Polish document converter.                                        */
/* IBM Latin 2 (code page 852)                                       */
/*********************************************************************/
#include <stdio.h>
#include "polcnv.h"

/*-------------------------------------------------------------------*/
#define LATIN_2_SIZE 128
unicode latin_2_tbl[LATIN_2_SIZE][2] = /* IBM Latin 2 */
  {
    { 0x080,  0x00c7 }, /* LATIN CAPITAL LETTER C WITH CEDILLA */
    { 0x081,  0x00fc }, /* LATIN SMALL LETTER U WITH DIAERESIS */
    { 0x082,  0x00e9 }, /* LATIN SMALL LETTER E WITH ACUTE */
    { 0x083,  0x00e2 }, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */
    { 0x084,  0x00e4 }, /* LATIN SMALL LETTER A WITH DIAERESIS */
    { 0x085,  0x016f }, /* LATIN SMALL LETTER U WITH RING ABOVE */
    { 0x086,  0x0107 }, /* LATIN SMALL LETTER C WITH ACUTE */
    { 0x087,  0x00e7 }, /* LATIN SMALL LETTER C WITH CEDILLA */
    { 0x088,  0x0142 }, /* LATIN SMALL LETTER L WITH STROKE */
    { 0x089,  0x00eb }, /* LATIN SMALL LETTER E WITH DIAERESIS */
    { 0x08a,  0x0150 }, /* LATIN CAPITAL LETTER O WITH DOUBLE ACUTE */
    { 0x08b,  0x0151 }, /* LATIN SMALL LETTER O WITH DOUBLE ACUTE */
    { 0x08c,  0x00ee }, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */
    { 0x08d,  0x0179 }, /* LATIN CAPITAL LETTER Z WITH ACUTE */
    { 0x08e,  0x00c4 }, /* LATIN CAPITAL LETTER A WITH DIAERESIS */
    { 0x08f,  0x0106 }, /* LATIN CAPITAL LETTER C WITH ACUTE */
    { 0x090,  0x00c9 }, /* LATIN CAPITAL LETTER E WITH ACUTE */
    { 0x091,  0x0139 }, /* LATIN CAPITAL LETTER L WITH ACUTE */
    { 0x092,  0x013a }, /* LATIN SMALL LETTER L WITH ACUTE */
    { 0x093,  0x00f4 }, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */
    { 0x094,  0x00f6 }, /* LATIN SMALL LETTER O WITH DIAERESIS */
    { 0x095,  0x013d }, /* LATIN CAPITAL LETTER L WITH CARON */
    { 0x096,  0x013e }, /* LATIN SMALL LETTER L WITH CARON */
    { 0x097,  0x015a }, /* LATIN CAPITAL LETTER S WITH ACUTE */
    { 0x098,  0x015b }, /* LATIN SMALL LETTER S WITH ACUTE */
    { 0x099,  0x00d6 }, /* LATIN CAPITAL LETTER O WITH DIAERESIS */
    { 0x09a,  0x00dc }, /* LATIN CAPITAL LETTER U WITH DIAERESIS */
    { 0x09b,  0x0164 }, /* LATIN CAPITAL LETTER T WITH CARON */
    { 0x09c,  0x0165 }, /* LATIN SMALL LETTER T WITH CARON */
    { 0x09d,  0x0141 }, /* LATIN CAPITAL LETTER L WITH STROKE */
    { 0x09e,  0x00d7 }, /* MULTIPLICATION SIGN */
    { 0x09f,  0x010d }, /* LATIN SMALL LETTER C WITH CARON */
    { 0x0a0,  0x00e1 }, /* LATIN SMALL LETTER A WITH ACUTE */
    { 0x0a1,  0x00ed }, /* LATIN SMALL LETTER I WITH ACUTE */
    { 0x0a2,  0x00f3 }, /* LATIN SMALL LETTER O WITH ACUTE */
    { 0x0a3,  0x00fa }, /* LATIN SMALL LETTER U WITH ACUTE */
    { 0x0a4,  0x0104 }, /* LATIN CAPITAL LETTER A WITH OGONEK */
    { 0x0a5,  0x0105 }, /* LATIN SMALL LETTER A WITH OGONEK */
    { 0x0a6,  0x017d }, /* LATIN CAPITAL LETTER Z WITH CARON */
    { 0x0a7,  0x017e }, /* LATIN SMALL LETTER Z WITH CARON */
    { 0x0a8,  0x0118 }, /* LATIN CAPITAL LETTER E WITH OGONEK */
    { 0x0a9,  0x0119 }, /* LATIN SMALL LETTER E WITH OGONEK */
    { 0x0aa,  0x00ac }, /* NOT SIGN */
    { 0x0ab,  0x017a }, /* LATIN SMALL LETTER Z WITH ACUTE */
    { 0x0ac,  0x010c }, /* LATIN CAPITAL LETTER C WITH CARON */
    { 0x0ad,  0x015f }, /* LATIN SMALL LETTER S WITH CEDILLA */
    { 0x0ae,  0x00ab }, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */
    { 0x0af,  0x00bb }, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */
    { 0x0b0,  0x2591 }, /* LIGHT SHADE */
    { 0x0b1,  0x2592 }, /* MEDIUM SHADE */
    { 0x0b2,  0x2593 }, /* DARK SHADE */
    { 0x0b3,  0x2502 }, /* BOX DRAWINGS LIGHT VERTICAL */
    { 0x0b4,  0x2524 }, /* BOX DRAWINGS LIGHT VERTICAL AND LEFT */
    { 0x0b5,  0x00c1 }, /* LATIN CAPITAL LETTER A WITH ACUTE */
    { 0x0b6,  0x00c2 }, /* LATIN CAPITAL LETTER A WITH CIRCUMFLEX */
    { 0x0b7,  0x011a }, /* LATIN CAPITAL LETTER E WITH CARON */
    { 0x0b8,  0x015e }, /* LATIN CAPITAL LETTER S WITH CEDILLA */
    { 0x0b9,  0x2563 }, /* BOX DRAWINGS DOUBLE VERTICAL AND LEFT */
    { 0x0ba,  0x2551 }, /* BOX DRAWINGS DOUBLE VERTICAL */
    { 0x0bb,  0x2557 }, /* BOX DRAWINGS DOUBLE DOWN AND LEFT */
    { 0x0bc,  0x255d }, /* BOX DRAWINGS DOUBLE UP AND LEFT */
    { 0x0bd,  0x017b }, /* LATIN CAPITAL LETTER Z WITH DOT ABOVE */
    { 0x0be,  0x017c }, /* LATIN SMALL LETTER Z WITH DOT ABOVE */
    { 0x0bf,  0x2510 }, /* BOX DRAWINGS LIGHT DOWN AND LEFT */
    { 0x0c0,  0x2514 }, /* BOX DRAWINGS LIGHT UP AND RIGHT */
    { 0x0c1,  0x2534 }, /* BOX DRAWINGS LIGHT UP AND HORIZONTAL */
    { 0x0c2,  0x252c }, /* BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */
    { 0x0c3,  0x251c }, /* BOX DRAWINGS LIGHT VERTICAL AND RIGHT */
    { 0x0c4,  0x2500 }, /* BOX DRAWINGS LIGHT HORIZONTAL */
    { 0x0c5,  0x253c }, /* BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */
    { 0x0c6,  0x0102 }, /* LATIN CAPITAL LETTER A WITH BREVE */
    { 0x0c7,  0x0103 }, /* LATIN SMALL LETTER A WITH BREVE */
    { 0x0c8,  0x255a }, /* BOX DRAWINGS DOUBLE UP AND RIGHT */
    { 0x0c9,  0x2554 }, /* BOX DRAWINGS DOUBLE DOWN AND RIGHT */
    { 0x0ca,  0x2569 }, /* BOX DRAWINGS DOUBLE UP AND HORIZONTAL */
    { 0x0cb,  0x2566 }, /* BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL */
    { 0x0cc,  0x2560 }, /* BOX DRAWINGS DOUBLE VERTICAL AND RIGHT */
    { 0x0cd,  0x2550 }, /* BOX DRAWINGS DOUBLE HORIZONTAL */
    { 0x0ce,  0x256c }, /* BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL */
    { 0x0cf,  0x00a4 }, /* CURRENCY SIGN */
    { 0x0d0,  0x0111 }, /* LATIN SMALL LETTER D WITH STROKE */
    { 0x0d1,  0x0110 }, /* LATIN CAPITAL LETTER D WITH STROKE */
    { 0x0d2,  0x010e }, /* LATIN CAPITAL LETTER D WITH CARON */
    { 0x0d3,  0x00cb }, /* LATIN CAPITAL LETTER E WITH DIAERESIS */
    { 0x0d4,  0x010f }, /* LATIN SMALL LETTER D WITH CARON */
    { 0x0d5,  0x0147 }, /* LATIN CAPITAL LETTER N WITH CARON */
    { 0x0d6,  0x00cd }, /* LATIN CAPITAL LETTER I WITH ACUTE */
    { 0x0d7,  0x00ce }, /* LATIN CAPITAL LETTER I WITH CIRCUMFLEX */
    { 0x0d8,  0x011b }, /* LATIN SMALL LETTER E WITH CARON */
    { 0x0d9,  0x2518 }, /* BOX DRAWINGS LIGHT UP AND LEFT */
    { 0x0da,  0x250c }, /* BOX DRAWINGS LIGHT DOWN AND RIGHT */
    { 0x0db,  0x2588 }, /* FULL BLOCK */
    { 0x0dc,  0x2584 }, /* LOWER HALF BLOCK */
    { 0x0dd,  0x0162 }, /* LATIN CAPITAL LETTER T WITH CEDILLA */
    { 0x0de,  0x016e }, /* LATIN CAPITAL LETTER U WITH RING ABOVE */
    { 0x0df,  0x2580 }, /* UPPER HALF BLOCK */
    { 0x0e0,  0x00d3 }, /* LATIN CAPITAL LETTER O WITH ACUTE */
    { 0x0e1,  0x00df }, /* LATIN SMALL LETTER SHARP S */
    { 0x0e2,  0x00d4 }, /* LATIN CAPITAL LETTER O WITH CIRCUMFLEX */
    { 0x0e3,  0x0143 }, /* LATIN CAPITAL LETTER N WITH ACUTE */
    { 0x0e4,  0x0144 }, /* LATIN SMALL LETTER N WITH ACUTE */
    { 0x0e5,  0x0148 }, /* LATIN SMALL LETTER N WITH CARON */
    { 0x0e6,  0x0160 }, /* LATIN CAPITAL LETTER S WITH CARON */
    { 0x0e7,  0x0161 }, /* LATIN SMALL LETTER S WITH CARON */
    { 0x0e8,  0x0154 }, /* LATIN CAPITAL LETTER R WITH ACUTE */
    { 0x0e9,  0x00da }, /* LATIN CAPITAL LETTER U WITH ACUTE */
    { 0x0ea,  0x0155 }, /* LATIN SMALL LETTER R WITH ACUTE */
    { 0x0eb,  0x0170 }, /* LATIN CAPITAL LETTER U WITH DOUBLE ACUTE */
    { 0x0ec,  0x00fd }, /* LATIN SMALL LETTER Y WITH ACUTE */
    { 0x0ed,  0x00dd }, /* LATIN CAPITAL LETTER Y WITH ACUTE */
    { 0x0ee,  0x0163 }, /* LATIN SMALL LETTER T WITH CEDILLA */
    { 0x0ef,  0x00b4 }, /* ACUTE ACCENT */
    { 0x0f0,  0x00ad }, /* SOFT HYPHEN */
    { 0x0f1,  0x02dd }, /* DOUBLE ACUTE ACCENT */
    { 0x0f2,  0x02db }, /* OGONEK */
    { 0x0f3,  0x02c7 }, /* CARON */
    { 0x0f4,  0x02d8 }, /* BREVE */
    { 0x0f5,  0x00a7 }, /* SECTION SIGN */
    { 0x0f6,  0x00f7 }, /* DIVISION SIGN */
    { 0x0f7,  0x00b8 }, /* CEDILLA */
    { 0x0f8,  0x00b0 }, /* DEGREE SIGN */
    { 0x0f9,  0x00a8 }, /* DIAERESIS */
    { 0x0fa,  0x02d9 }, /* DOT ABOVE */
    { 0x0fb,  0x0171 }, /* LATIN SMALL LETTER U WITH DOUBLE ACUTE */
    { 0x0fc,  0x0158 }, /* LATIN CAPITAL LETTER R WITH CARON */
    { 0x0fd,  0x0159 }, /* LATIN SMALL LETTER R WITH CARON */
    { 0x0fe,  0x25a0 }, /* BLACK SQUARE */
    { 0x0ff,  0x00a0 }  /* NO-BREAK SPACE */
  };

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
int test_latin_2( void )
  {
  return table_test( latin_2_tbl, LATIN_2_SIZE );
  }

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
void init_latin_2( void )
  {
  trans[ TYPE_LATIN_2 ].key		= (char*)"-l";
  trans[ TYPE_LATIN_2 ].long_key	= (char*)"-cp852";
  trans[ TYPE_LATIN_2 ].name		= (char*)"IBM Latin 2 (code page 852)";
  trans[ TYPE_LATIN_2 ].reset_inp       = NULL;;
  trans[ TYPE_LATIN_2 ].reset_out       = NULL;;
  trans[ TYPE_LATIN_2 ].decode          = table_decode;
  trans[ TYPE_LATIN_2 ].encode          = table_encode;
  trans[ TYPE_LATIN_2 ].inp_tbl         = latin_2_tbl;
  trans[ TYPE_LATIN_2 ].inp_tbl_size    = LATIN_2_SIZE;
  trans[ TYPE_LATIN_2 ].out_tbl         = latin_2_tbl;
  trans[ TYPE_LATIN_2 ].out_tbl_size    = LATIN_2_SIZE;
  trans[ TYPE_LATIN_2 ].buf_tst         = NULL;
  trans[ TYPE_LATIN_2 ].freq_tst        = test_latin_2;
  }

/*********************************************************************/
