/*********************************************************************/
/* texpl.c      v 2.3      by J.Sobczyk IAPW       2001.08.02  17:01 */
/*                                                                   */
/* Polish document converter.                                        */
/* TeX PL                                                            */
/*********************************************************************/
#include <stdio.h>
#include "polcnv.h"

/*********************************************************************/
code_tbl texpl_tbl =
  {
    { 0x0a1,   0x0105 },   /* LATIN SMALL LETTER A WITH OGONEK */
    { 0x0a2,   0x0107 },   /* LATIN SMALL LETTER C WITH ACUTE */
    { 0x0a6,   0x0119 },   /* LATIN SMALL LETTER E WITH OGONEK */
    { 0x0aa,   0x0142 },   /* LATIN SMALL LETTER L WITH STROKE */
    { 0x0ab,   0x0144 },   /* LATIN SMALL LETTER N WITH ACUTE */
    { 0x0f3,   0x00F3 },   /* LATIN SMALL LETTER O WITH ACUTE */
    { 0x0b1,   0x015B },   /* LATIN SMALL LETTER S WITH ACUTE */
    { 0x0b9,   0x017A },   /* LATIN SMALL LETTER Z WITH ACUTE */
    { 0x0bb,   0x017C },   /* LATIN SMALL LETTER Z WITH DOT ABOVE */
    { 0x081,   0x0104 },   /* LATIN CAPITAL LETTER A WITH OGONEK */
    { 0x082,   0x0106 },   /* LATIN CAPITAL LETTER C WITH ACUTE */
    { 0x086,   0x0118 },   /* LATIN CAPITAL LETTER E WITH OGONEK */
    { 0x08a,   0x0141 },   /* LATIN CAPITAL LETTER L WITH STROKE */
    { 0x08b,   0x0143 },   /* LATIN CAPITAL LETTER N WITH ACUTE */
    { 0x0d3,   0x00D3 },   /* LATIN CAPITAL LETTER O WITH ACUTE */
    { 0x091,   0x015A },   /* LATIN CAPITAL LETTER S WITH ACUTE */
    { 0x099,   0x0179 },   /* LATIN CAPITAL LETTER Z WITH ACUTE */
    { 0x09b,   0x017B }    /* LATIN CAPITAL LETTER Z WITH DOT ABOVE */
  };

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
int test_texpl( void )
  {
  return table_test( texpl_tbl, 2*POL_NR );
  }

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
void init_texpl( void )
  {
  trans[ TYPE_TEXPL ].key		= (char*)"";
  trans[ TYPE_TEXPL ].long_key		= (char*)"-texpl";
  trans[ TYPE_TEXPL ].name		= (char*)"TeX PL";
  trans[ TYPE_TEXPL ].reset_inp       	= NULL;
  trans[ TYPE_TEXPL ].reset_out       	= NULL;
  trans[ TYPE_TEXPL ].decode          	= table_decode;
  trans[ TYPE_TEXPL ].encode          	= table_encode;
  trans[ TYPE_TEXPL ].inp_tbl         	= texpl_tbl;
  trans[ TYPE_TEXPL ].inp_tbl_size    	= 2*POL_NR;
  trans[ TYPE_TEXPL ].out_tbl         	= texpl_tbl;
  trans[ TYPE_TEXPL ].out_tbl_size    	= 2*POL_NR;
  trans[ TYPE_TEXPL ].buf_tst         	= NULL;
  trans[ TYPE_TEXPL ].freq_tst        	= test_texpl;
  }

/*********************************************************************/
